diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
index 06d0e3f6d5..0c1e03f044 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
@@ -613,376 +665,466 @@ t4_iq_gts_update(struct sge_iq *iq, t4_intr_config_t cfg, uint16_t cidx_incr)
  * associated with the IQ.
  */
 static void
-t4_iq_gts_incr(struct sge_iq *iq, uint16_t cidx_incr)
+t4_iq_gts_incr(t4_sge_iq_t *iq, uint16_t cidx_incr)
 {
 	if (cidx_incr == 0) {
 		return;
 	}
 
 	const uint32_t value =
-	    V_INGRESSQID((uint32_t)iq->cntxt_id) |
+	    V_INGRESSQID((uint32_t)iq->tsi_cntxt_id) |
 	    V_CIDXINC((uint32_t)cidx_incr) |
 	    V_SEINTARM((uint32_t)V_QINTR_TIMER_IDX(X_TIMERREG_UPDATE_CIDX));
-	t4_write_reg(iq->adapter, MYPF_REG(A_SGE_PF_GTS), value);
+	t4_write_reg(iq->tsi_adapter, MYPF_REG(A_SGE_PF_GTS), value);
 }
 
-static void
-t4_intr_rx_work(struct sge_iq *iq)
-{
-	mblk_t *mp = NULL;
-	struct sge_rxq *rxq = iq_to_rxq(iq);	/* Use iff iq is part of rxq */
-	RXQ_LOCK(rxq);
-	if (!iq->polling) {
-		mp = t4_ring_rx(rxq, iq->qsize/8);
-		t4_iq_gts_update(iq, iq->intr_params, 0);
-	}
-	RXQ_UNLOCK(rxq);
-	if (mp != NULL) {
-		mac_rx_ring(rxq->port->mh, rxq->ring_handle, mp,
-		    rxq->ring_gen_num);
-	}
-}
-
-/* Deals with interrupts on the given ingress queue */
-/* ARGSUSED */
 uint_t
-t4_intr(caddr_t arg1, caddr_t arg2)
+t4_intr_all(caddr_t arg1, caddr_t arg2)
 {
-	struct sge_iq *iq = (struct sge_iq *)arg2;
-	int state;
+	struct adapter *sc = (struct adapter *)arg1;
+
+	/* handle any device errors */
+	t4_write_reg(sc, MYPF_REG(A_PCIE_PF_CLI), 0);
+	(void) t4_slow_intr_handler(sc);
+
+	/* process fwq */
+	(void) t4_process_event_iq(&sc->sge.fwq);
 
-	/*
-	 * Right now receive polling is only enabled for MSI-X and
-	 * when we have enough msi-x vectors i.e no interrupt forwarding.
-	 */
-	if (iq->adapter->props.multi_rings) {
-		t4_intr_rx_work(iq);
-	} else {
-		state = atomic_cas_uint(&iq->state, IQS_IDLE, IQS_BUSY);
-		if (state == IQS_IDLE) {
-			(void) service_iq(iq, 0);
-			(void) atomic_cas_uint(&iq->state, IQS_BUSY, IQS_IDLE);
-		}
-	}
 	return (DDI_INTR_CLAIMED);
 }
 
-/* Deals with error interrupts */
-/* ARGSUSED */
 uint_t
 t4_intr_err(caddr_t arg1, caddr_t arg2)
 {
 	struct adapter *sc = (struct adapter *)arg1;
 
+	/* handle any device errors */
 	t4_write_reg(sc, MYPF_REG(A_PCIE_PF_CLI), 0);
 	(void) t4_slow_intr_handler(sc);
 
 	return (DDI_INTR_CLAIMED);
 }
 
-/*
- * t4_ring_rx - Process responses from an SGE response queue.
- *
- * This function processes responses from an SGE response queue up to the
- * supplied budget.  Responses include received packets as well as control
- * messages from FW or HW.
- *
- * It returns a chain of mblks containing the received data, to be
- * passed up to mac_rx_ring().
- */
-mblk_t *
-t4_ring_rx(struct sge_rxq *rxq, int budget)
-{
-	struct sge_iq *iq = &rxq->iq;
-	struct sge_fl *fl = &rxq->fl;		/* Use iff IQ_HAS_FL */
-	struct adapter *sc = iq->adapter;
-	struct rsp_ctrl *ctrl;
-	int ndescs = 0, fl_bufs_used = 0;
-	mblk_t *mblk_head = NULL, **mblk_tail = &mblk_head;
-	uint32_t received_bytes = 0, pkt_len = 0;
-	uint16_t err_vec;
-
-	while (is_new_response(iq, &ctrl)) {
-		membar_consumer();
-
-		const uint8_t type_gen = ctrl->u.type_gen;
-		const uint8_t rsp_type = G_RSPD_TYPE(type_gen);
-		const bool overflowed = (type_gen & F_RSPD_QOVFL) != 0;
-		const uint32_t data_len = BE_32(ctrl->pldbuflen_qid);
-
-		iq->stats.sis_processed++;
-		if (overflowed) {
-			iq->stats.sis_overflow++;
-		}
+uint_t
+t4_intr_fwq(caddr_t arg1, caddr_t arg2)
+{
+	struct adapter *sc = (struct adapter *)arg1;
 
-		const struct rss_header *rss =
-		    (const struct rss_header *)iq->cdesc;
-		mblk_t *m = NULL;
+	(void) t4_process_event_iq(&sc->sge.fwq);
 
-		switch (rsp_type) {
-		case X_RSPD_TYPE_FLBUF:
+	return (DDI_INTR_CLAIMED);
+}
 
-			ASSERT(iq->flags & IQ_HAS_FL);
+uint_t
+t4_intr_port_queue(caddr_t arg1, caddr_t arg2)
+{
+	t4_sge_iq_t *iq = (t4_sge_iq_t *)arg1;
 
-			if (CPL_RX_PKT == rss->opcode) {
-				const struct cpl_rx_pkt *cpl =
-				    t4_rss_payload(rss);
-				pkt_len = be16_to_cpu(cpl->len);
+	(void) t4_process_event_iq(iq);
 
-				if (iq->polling &&
-				    ((received_bytes + pkt_len) > budget))
-					goto done;
+	return (DDI_INTR_CLAIMED);
+}
 
-				m = get_fl_payload(sc, fl, data_len,
-				    &fl_bufs_used);
-				if (m == NULL)
-					goto done;
+static bool
+t4_fl_periodic_refill(struct sge_fl *fl)
+{
+	FL_LOCK(fl);
+	const bool starved = t4_fl_refill(fl, fl->bufs_cap / 8);
+	FL_UNLOCK(fl);
 
-				m->b_rptr += sc->sge.pktshift;
-				if (sc->params.tp.rx_pkt_encap) {
-					/* Enabled only in T6 config file */
-					err_vec = G_T6_COMPR_RXERR_VEC(
-					    ntohs(cpl->err_vec));
-				} else {
-					err_vec = ntohs(cpl->err_vec);
-				}
+	return (starved);
+}
 
-				const bool csum_ok = cpl->csum_calc && !err_vec;
+/*
+ * Convenience struct for tracking entry types while servicing an IQ.
+ * Used to communicate said counts through the t4-process-* probes.
+ */
+struct sge_iq_totals {
+	uint_t sit_desc;
+	uint_t sit_flbuf;
+	uint_t sit_cpl;
+	uint_t sit_intr;
+	uint_t sit_rx_bytes;
+};
 
-				/* TODO: what about cpl->ip_frag? */
-				if (csum_ok && !cpl->ip_frag) {
-					mac_hcksum_set(m, 0, 0, 0, 0xffff,
-					    HCK_FULLCKSUM_OK | HCK_FULLCKSUM |
-					    HCK_IPV4_HDRCKSUM_OK);
-					rxq->rxcsum++;
-				}
-				rxq->rxpkts++;
-				rxq->rxbytes += pkt_len;
-				received_bytes += pkt_len;
+/*
+ * Process entries on an event Ingress Queue. This type of queue receives
+ * firmware events, Tx EGR messages, and Rx forwarded interrupts only. It is
+ * used by the firmware queue and the individual port queues.
+ */
+static t4_iq_result_t
+t4_process_event_iq(t4_sge_iq_t *event_iq)
+{
+	int rc = TIR_SUCCESS;
+	struct adapter *sc = event_iq->tsi_adapter;
+
+	const uint_t desc_limit = event_iq->tsi_qsize / 8;
+	struct sge_iq_totals totals = { 0 };
+	uint_t cidx_incr = 0;
+	struct rsp_ctrl ctrl;
+	list_t iql_fwd;
+
+	ASSERT3S(event_iq->tsi_iqtype, ==, TIQT_EVENT);
+	ASSERT3P(event_iq->tsi_intr_evtq, ==, NULL);
+
+	IQ_LOCK(event_iq);
+	if ((event_iq->tsi_flags & IQ_ENABLED) == 0) {
+		IQ_UNLOCK(event_iq);
+		return (TIR_DISABLED);
+	}
 
-				*mblk_tail = m;
-				mblk_tail = &m->b_next;
+	list_create(&iql_fwd, sizeof (t4_sge_iq_t),
+	    offsetof(t4_sge_iq_t, tsi_intr_fwd_node));
 
-				break;
-			}
+	while (t4_get_new_rsp(event_iq, &ctrl)) {
+		const uint8_t rsp_type = G_RSPD_TYPE(ctrl.u.type_gen);
+		const bool overflowed = (ctrl.u.type_gen & F_RSPD_QOVFL) != 0;
 
-			m = get_fl_payload(sc, fl, data_len, &fl_bufs_used);
-			if (m == NULL)
-				goto done;
-			/* FALLTHROUGH */
+		if (overflowed) {
+			event_iq->tsi_stats.sis_overflow++;
+		}
+
+		const struct rss_header *rss =
+		    (const struct rss_header *)event_iq->tsi_cdesc;
+
+		DTRACE_PROBE3(t4__event__iq__entry, t4_sge_iq_t *, event_iq,
+		    struct rsp_ctrl *, &ctrl, struct rss_header *, rss);
+		ASSERT((rsp_type & (X_RSPD_TYPE_CPL | X_RSPD_TYPE_INTR)) != 0);
 
+		switch (rsp_type) {
 		case X_RSPD_TYPE_CPL:
-			(void) t4_handle_cpl_msg(iq, rss, m);
+			totals.sit_cpl++;
+			(void) t4_handle_cpl_msg(event_iq, rss, NULL);
+			break;
+
+		case X_RSPD_TYPE_INTR:
+			totals.sit_intr++;
+			const uint32_t tgt_qid = BE_32(ctrl.pldbuflen_qid);
+
+			t4_sge_iq_t *tgt_iq = *t4_iqmap_slot(sc, tgt_qid);
+			/*
+			 * Make sure the forwarded interrupt was sent to the
+			 * expected event queue.
+			 */
+			ASSERT3P(tgt_iq->tsi_intr_evtq, ==, event_iq);
+
+			if (!list_link_active(&tgt_iq->tsi_intr_fwd_node)) {
+				list_insert_tail(&iql_fwd, tgt_iq);
+			}
 			break;
 
 		default:
+			cxgb_printf(sc->dip, CE_WARN, "unexpected IQ entry "
+			    "type %d on IQ %u of type %d", rsp_type,
+			    event_iq->tsi_cntxt_id, event_iq->tsi_iqtype);
 			break;
 		}
-		iq_next(iq);
-		++ndescs;
-		if (!iq->polling && (ndescs == budget))
+
+		t4_iq_next_entry(event_iq);
+		cidx_incr++;
+		totals.sit_desc++;
+		event_iq->tsi_stats.sis_processed++;
+
+		if (cidx_incr == desc_limit) {
+			rc = TIR_BUDGET_MAX;
 			break;
+		}
 	}
 
-done:
+	/*
+	 * At this point we may have collected a number of interrupt forwarding
+	 * entries for Rx IQs, indicating that they have outstanding data ready
+	 * for consumption. We process those now while still in interrupt
+	 * context. We remain holding the event IQ's mutex while doing this
+	 * work. No additional interrupts should be generated for this event IQ
+	 * until after we have finished processing and re-armed the interrupt
+	 * via t4_iq_gts_update().
+	 *
+	 * There is a finite budget for processing each rx queue, and not all
+	 * data is guaranteed to be processed as part of this interrupt. Each rx
+	 * queue should re-arm its interrupt to trigger a fresh interrupt later
+	 * if polling mode has not been enabled.
+	 */
+	t4_sge_iq_t *rx_iq = NULL;
+	while ((rx_iq = list_remove_head(&iql_fwd)) != NULL) {
+		(void) t4_process_rx_iq(rx_iq, rx_iq->tsi_qsize / 8, NULL);
+	}
 
-	t4_iq_gts_incr(iq, ndescs);
+	/*
+	 * Send an update to the device about the event queue's new cidx and
+	 * re-arm its interrupt.
+	 */
+	ASSERT3U(cidx_incr, >, 0);
+	t4_iq_gts_update(event_iq, event_iq->tsi_gts_rearm, cidx_incr);
+	IQ_UNLOCK(event_iq);
 
-	if ((fl_bufs_used > 0) || (iq->flags & IQ_HAS_FL)) {
-		int starved;
-		FL_LOCK(fl);
-		fl->needed += fl_bufs_used;
-		starved = refill_fl(sc, fl, fl->cap / 8);
-		FL_UNLOCK(fl);
-		if (starved)
-			add_fl_to_sfl(sc, fl);
-	}
-	return (mblk_head);
+	DTRACE_PROBE3(t4__event__iq__processed, t4_sge_iq_t *, event_iq,
+	    struct sge_iq_totals *, &totals, t4_iq_result_t, rc);
+	return (rc);
 }
 
 /*
- * Deals with anything and everything on the given ingress queue.
+ * Process entries on an Rx Ingress Queue. When called from interrupt context
+ * 'desc_budget' should be non-zero and 'tpr' should be NULL. When called from
+ * polling context 'desc_budget' should be zero and 'tpr' should be non-NULL.
  */
-static int
-service_iq(struct sge_iq *iq, int budget)
+t4_iq_result_t
+t4_process_rx_iq(t4_sge_iq_t *rx_iq, uint_t desc_budget,
+    struct t4_poll_req *tpr)
 {
-	struct sge_iq *q;
-	struct sge_rxq *rxq = iq_to_rxq(iq);	/* Use iff iq is part of rxq */
-	struct sge_fl *fl = &rxq->fl;		/* Use iff IQ_HAS_FL */
-	struct adapter *sc = iq->adapter;
-	struct rsp_ctrl *ctrl;
-	int ndescs = 0, fl_bufs_used = 0;
-	int starved;
-	STAILQ_HEAD(, sge_iq) iql = STAILQ_HEAD_INITIALIZER(iql);
-
-	const uint_t limit = (budget != 0) ? budget : iq->qsize / 8;
-
+	struct adapter *sc = rx_iq->tsi_adapter;
+	struct sge_fl *fl = rx_iq->tsi_fl;
+	struct sge_rxq *rxq = t4_iq_to_rxq(rx_iq);
+	const uint_t byte_limit = (tpr != NULL) ? tpr->tpr_byte_budget : 0;
+	mblk_t *mp_head = NULL, **mp_tail = &mp_head;
+	struct sge_iq_totals totals = { 0 };
+	uint_t cidx_incr = 0;
+	struct rsp_ctrl ctrl;
+	t4_iq_result_t rc = TIR_SUCCESS;
+
+	ASSERT3S(rx_iq->tsi_iqtype, ==, TIQT_ETH_RX);
+	ASSERT3P(rx_iq->tsi_intr_evtq, !=, NULL);
+	ASSERT3P(rxq, !=, NULL);
+	/* Rx queues require an FL. */
+	ASSERT3P(fl, !=, NULL);
 	/*
-	 * We always come back and check the descriptor ring for new indirect
-	 * interrupts and other responses after running a single handler.
+	 * The desc_budget is used only when processing in interrupt context.
+	 * The tpr is used only when proessing in polling context.
 	 */
-	for (;;) {
-		while (is_new_response(iq, &ctrl)) {
-			membar_consumer();
-
-			const uint8_t type_gen = ctrl->u.type_gen;
-			const uint8_t rsp_type = G_RSPD_TYPE(type_gen);
-			const uint32_t dlen_qid = BE_32(ctrl->pldbuflen_qid);
-
-			mblk_t *m = NULL;
-			const struct rss_header *rss =
-			    (const struct rss_header *)iq->cdesc;
-
-			switch (rsp_type) {
-			case X_RSPD_TYPE_FLBUF:
-
-				ASSERT(iq->flags & IQ_HAS_FL);
-
-				m = get_fl_payload(sc, fl, dlen_qid,
-				    &fl_bufs_used);
-				if (m == NULL) {
-					/*
-					 * Rearm the iq with a
-					 * longer-than-default timer
-					 */
-					t4_iq_gts_update(iq, TIC_TIMER5,
-					    ndescs);
-					if (fl_bufs_used > 0) {
-						ASSERT(iq->flags & IQ_HAS_FL);
-						FL_LOCK(fl);
-						fl->needed += fl_bufs_used;
-						starved = refill_fl(sc, fl,
-						    fl->cap / 8);
-						FL_UNLOCK(fl);
-						if (starved)
-							add_fl_to_sfl(sc, fl);
-					}
-					return (0);
-				}
+	ASSERT(desc_budget == 0 || tpr == NULL);
+
+	IQ_LOCK(rx_iq);
+	const bool is_polling = (rx_iq->tsi_flags & IQ_POLLING) != 0;
+	if ((rx_iq->tsi_flags & IQ_ENABLED) == 0) {
+		IQ_UNLOCK(rx_iq);
+		return (TIR_DISABLED);
+	} else if (is_polling && tpr == NULL) {
+		/*
+		 * Skip IQ processing driven from interrupt when port is
+		 * configured for polling.
+		 */
+		IQ_UNLOCK(rx_iq);
+		return (TIR_POLLING);
+	}
 
-			/* FALLTHRU */
-			case X_RSPD_TYPE_CPL:
-				(void) t4_handle_cpl_msg(iq, rss, m);
-				break;
+	while (t4_get_new_rsp(rx_iq, &ctrl)) {
+		const uint8_t rsp_type = G_RSPD_TYPE(ctrl.u.type_gen);
+		const bool overflowed = (ctrl.u.type_gen & F_RSPD_QOVFL) != 0;
 
-			case X_RSPD_TYPE_INTR:
+		if (overflowed) {
+			rx_iq->tsi_stats.sis_overflow++;
+		}
 
-				/*
-				 * Interrupts should be forwarded only to queues
-				 * that are not forwarding their interrupts.
-				 * This means service_iq can recurse but only 1
-				 * level deep.
-				 */
-				ASSERT(budget == 0);
-
-				q = *t4_iqmap_slot(sc, dlen_qid);
-				if (atomic_cas_uint(&q->state, IQS_IDLE,
-				    IQS_BUSY) == IQS_IDLE) {
-					if (service_iq(q, q->qsize / 8) == 0) {
-						(void) atomic_cas_uint(
-						    &q->state, IQS_BUSY,
-						    IQS_IDLE);
-					} else {
-						STAILQ_INSERT_TAIL(&iql, q,
-						    link);
-					}
+		const struct rss_header *rss =
+		    (const struct rss_header *)rx_iq->tsi_cdesc;
+
+		DTRACE_PROBE3(t4__rx__iq__entry, t4_sge_iq_t *, rx_iq,
+		    struct rsp_ctrl *, &ctrl, struct rss_header *, rss);
+
+		switch (rsp_type) {
+		case X_RSPD_TYPE_FLBUF: {
+			const uint32_t dlen_nb = BE_32(ctrl.pldbuflen_qid);
+			const struct cpl_rx_pkt *cpl = t4_rss_payload(rss);
+
+			if (rss->opcode == CPL_RX_PKT) {
+				const uint16_t pkt_len = BE_16(cpl->len);
+				const uint_t new_total =
+				    totals.sit_rx_bytes + pkt_len;
+
+				if (byte_limit != 0 && new_total > byte_limit) {
+					rc = TIR_BUDGET_MAX;
+					goto bail;
 				}
-				break;
+			}
 
-			default:
-				break;
+			const bool newbuf = (dlen_nb & F_RSPD_NEWBUF) != 0;
+			const uint32_t data_len = G_RSPD_LEN(dlen_nb);
+			mblk_t *mp = t4_fl_get_payload(fl, data_len, newbuf);
+			if (mp == NULL) {
+				/* Rearm IQ with longer-than-default timer */
+				t4_iq_gts_update(rx_iq, TGC_TIMER5, cidx_incr);
+				cidx_incr = 0;
+				rc = TIR_ALLOC_FAIL;
+				goto bail;
 			}
 
-			iq_next(iq);
-			if (++ndescs == limit) {
-				t4_iq_gts_incr(iq, ndescs);
-				ndescs = 0;
-
-				if (fl_bufs_used > 0) {
-					ASSERT(iq->flags & IQ_HAS_FL);
-					FL_LOCK(fl);
-					fl->needed += fl_bufs_used;
-					(void) refill_fl(sc, fl, fl->cap / 8);
-					FL_UNLOCK(fl);
-					fl_bufs_used = 0;
+			/*
+			 * Add this entry to the totals once we are past the
+			 * possible bail-outs above.
+			 */
+			totals.sit_flbuf++;
+
+			if (rss->opcode == CPL_RX_PKT) {
+				mp->b_rptr += sc->sge.pktshift;
+
+				uint16_t err_vec;
+				if (sc->params.tp.rx_pkt_encap) {
+					/* Enabled only in T6 config file */
+					err_vec = G_T6_COMPR_RXERR_VEC(
+					    ntohs(cpl->err_vec));
+				} else {
+					err_vec = ntohs(cpl->err_vec);
 				}
 
-				if (budget != 0)
-					return (EINPROGRESS);
+				const bool csum_ok = cpl->csum_calc && !err_vec;
+
+				if (csum_ok && !cpl->ip_frag) {
+					mac_hcksum_set(mp, 0, 0, 0, 0xffff,
+					    HCK_FULLCKSUM_OK | HCK_FULLCKSUM |
+					    HCK_IPV4_HDRCKSUM_OK);
+					rxq->stats.rxcsum++;
+				}
+
+				const uint16_t pkt_len = BE_16(cpl->len);
+				rxq->stats.rxpkts++;
+				rxq->stats.rxbytes += pkt_len;
+				totals.sit_rx_bytes += pkt_len;
+
+				*mp_tail = mp;
+				mp_tail = &mp->b_next;
+			} else {
+				(void) t4_handle_cpl_msg(rx_iq, rss, mp);
 			}
+			break;
 		}
 
-		if (STAILQ_EMPTY(&iql) != 0)
+		default:
+			cxgb_printf(sc->dip, CE_WARN, "unexpected IQ entry "
+			    "type %d on IQ %u of type %d", rsp_type,
+			    rx_iq->tsi_cntxt_id, rx_iq->tsi_iqtype);
+#ifdef DEBUG
+			panic("unexpected IQ entry on rx queue");
+#endif
 			break;
+		}
+
+		t4_iq_next_entry(rx_iq);
+		cidx_incr++;
+		totals.sit_desc++;
+		rx_iq->tsi_stats.sis_processed++;
 
 		/*
-		 * Process the head only, and send it to the back of the list if
-		 * it's still not done.
+		 * The desc_budget value is non-zero only when processing in
+		 * interrupt context. In this case we honor the desc_limit. In
+		 * polling mode we are passed a byte-based budget and disregard
+		 * the the desc_limit.
 		 */
-		q = STAILQ_FIRST(&iql);
-		STAILQ_REMOVE_HEAD(&iql, link);
-		if (service_iq(q, q->qsize / 8) == 0)
-			(void) atomic_cas_uint(&q->state, IQS_BUSY, IQS_IDLE);
-		else
-			STAILQ_INSERT_TAIL(&iql, q, link);
+		if (desc_budget != 0 && cidx_incr == desc_budget) {
+			rc = TIR_BUDGET_MAX;
+			goto bail;
+		}
 	}
 
-	t4_iq_gts_update(iq, iq->intr_params, ndescs);
+bail:
+	if (tpr != NULL) {
+		/*
+		 * Do not re-arm interrupts while this IQ is being polled.
+		 * Just update the CIDX as necessary.
+		 */
+		if (cidx_incr != 0) {
+			t4_iq_gts_incr(rx_iq, cidx_incr);
+		}
+	} else {
+		/*
+		 * Just being extra sure that any future code changes keep this
+		 * code path to interrupt processing only.
+		 */
+		ASSERT3U(desc_budget, >, 0);
+		ASSERT3P(tpr, ==, NULL);
 
-	if (iq->flags & IQ_HAS_FL) {
-		FL_LOCK(fl);
-		fl->needed += fl_bufs_used;
-		starved = refill_fl(sc, fl, fl->cap / 4);
-		FL_UNLOCK(fl);
-		if (starved != 0)
-			add_fl_to_sfl(sc, fl);
+		/*
+		 * Make sure to re-arm the interrupt for this rx queue.
+		 * Remember, the actual interrupt is delivered to the event
+		 * queue (rq_iq->tsi_intr_evtq), but the generation of the
+		 * forwarded interrupt event requires arming the interrupt on
+		 * this rx queue.
+		 */
+		t4_iq_gts_update(rx_iq, rx_iq->tsi_gts_rearm, cidx_incr);
 	}
 
-	return (0);
+	/*
+	 * Take a snapshot of the ring generation number prior to dropping the
+	 * IQ/RXQ lock, in case we need it to pass packets into the mac RX path.
+	 */
+	const uint64_t ring_gen_num = rxq->ring_gen_num;
+	IQ_UNLOCK(rx_iq);
+
+	/*
+	 * First we deliver the packets up to mac to give the client a chance to
+	 * consume these mblks before the driver attempts to refill them.
+	 */
+	if (mp_head != NULL) {
+		if (tpr != NULL) {
+			tpr->tpr_mp = mp_head;
+		} else {
+			mac_rx_ring(rxq->port->mh, rxq->ring_handle, mp_head,
+			    ring_gen_num);
+		}
+	}
+
+	/*
+	 * Next we refill some FL buffers. If the FL is "starving", we enqueue
+	 * it on the starving list for further refilling on a background
+	 * thread.
+	 */
+	if (fl != NULL && t4_fl_periodic_refill(fl)) {
+		t4_sfl_enqueue(sc, fl);
+	}
+	DTRACE_PROBE3(t4__rx__iq__processed, t4_sge_iq_t *, rx_iq,
+	    struct sge_iq_totals *, &totals, t4_iq_result_t, rc);
+	return (rc);
 }
 
 /* Per-packet header in a coalesced tx WR, before the SGL starts (in flits) */
-#define	TXPKTS_PKT_HDR ((\
+#define	TXPKTS_PKT_HDR_FLITS ((\
 	sizeof (struct ulp_txpkt) + \
 	sizeof (struct ulptx_idata) + \
-	sizeof (struct cpl_tx_pkt_core)) / 8)
+	sizeof (struct cpl_tx_pkt_core)) / FLIT_NUM_BYTES)
 
 /* Header of a coalesced tx WR, before SGL of first packet (in flits) */
-#define	TXPKTS_WR_HDR (\
-	sizeof (struct fw_eth_tx_pkts_wr) / 8 + \
-	TXPKTS_PKT_HDR)
+#define	TXPKTS_WR_HDR_FLITS (\
+	sizeof (struct fw_eth_tx_pkts_wr) / FLIT_NUM_BYTES + \
+	TXPKTS_PKT_HDR_FLITS)
 
 /* Header of a tx WR, before SGL of first packet (in flits) */
-#define	TXPKT_WR_HDR ((\
+#define	TXPKT_WR_HDR_FLITS ((\
 	sizeof (struct fw_eth_tx_pkt_wr) + \
-	sizeof (struct cpl_tx_pkt_core)) / 8)
+	sizeof (struct cpl_tx_pkt_core)) / FLIT_NUM_BYTES)
 
 /* Header of a tx LSO WR, before SGL of first packet (in flits) */
-#define	TXPKT_LSO_WR_HDR ((\
+#define	TXPKT_LSO_WR_HDR_FLITS ((\
 	sizeof (struct fw_eth_tx_pkt_wr) + \
 	sizeof (struct cpl_tx_pkt_lso_core) + \
-	sizeof (struct cpl_tx_pkt_core)) / 8)
+	sizeof (struct cpl_tx_pkt_core)) / FLIT_NUM_BYTES)
 
 mblk_t *
 t4_eth_tx(void *arg, mblk_t *frame)
 {
-	struct sge_txq *txq = (struct sge_txq *)arg;
+	struct sge_txq *txq = arg;
 	struct port_info *pi = txq->port;
-	struct sge_eq *eq = &txq->eq;
-	mblk_t *next_frame;
-	int rc, coalescing;
-	struct txpkts txpkts;
-	struct txinfo txinfo;
+	t4_sge_eq_t *eq = &txq->eq;
+	mblk_t *next_frame = NULL;
+	int coalescing = 0;
+	struct txpkts txpkts = {};
+	struct txinfo txinfo = {};
 
 	txpkts.npkt = 0; /* indicates there's nothing in txpkts */
-	coalescing = 0;
 
 	TXQ_LOCK(txq);
-	if (eq->avail < 8)
-		(void) t4_tx_reclaim_descs(txq, 8, NULL);
-	for (; frame; frame = next_frame) {
+	if ((eq->tse_flags & EQ_ENABLED) == 0) {
+		/* Apply flow control until EQ is enabled. */
+		TXQ_UNLOCK(txq);
+		return (frame);
+	}
+
+	/* We always strive to send the maximum size WR. */
+	if (eq->tse_avail < TX_WR_MAX_CREDITS) {
+		(void) t4_tx_reclaim_credits(txq, TX_WR_MAX_CREDITS, NULL);
+	}
+	for (; frame != NULL; frame = next_frame) {
+		int rc = 0;
 
-		if (eq->avail < 8)
+		if (eq->tse_avail < TX_WR_MAX_CREDITS)
 			break;
 
 		next_frame = frame->b_next;
@@ -1006,7 +1148,6 @@ t4_eth_tx(void *arg, mblk_t *frame)
 				 * state in mac to continue transmissions.
 				 */
 				t4_write_flush_wr(txq);
-
 				break;
 			}
 
@@ -1020,9 +1161,7 @@ t4_eth_tx(void *arg, mblk_t *frame)
 
 		if (coalescing != 0 &&
 		    add_to_txpkts(txq, &txpkts, frame, &txinfo) == 0) {
-
 			/* Successfully absorbed into txpkts */
-
 			write_ulp_cpl_sgl(pi, txq, &txpkts, &txinfo);
 			goto doorbell;
 		}
@@ -1038,8 +1177,11 @@ t4_eth_tx(void *arg, mblk_t *frame)
 		/* We're sending out individual frames now */
 		coalescing = 0;
 
-		if (eq->avail < 8)
-			(void) t4_tx_reclaim_descs(txq, 8, NULL);
+		if (eq->tse_avail < TX_WR_MAX_CREDITS) {
+			(void) t4_tx_reclaim_credits(txq, TX_WR_MAX_CREDITS,
+			    NULL);
+		}
+
 		rc = write_txpkt_wr(pi, txq, frame, &txinfo);
 		if (rc != 0) {
 
@@ -1051,7 +1193,7 @@ t4_eth_tx(void *arg, mblk_t *frame)
 			 * can't send out the frame.  What's worse, we have to
 			 * spend even more time freeing up everything in txinfo.
 			 */
-			txq->qfull++;
+			txq->stats.qfull++;
 			free_txinfo_resources(txq, &txinfo);
 
 			frame->b_next = next_frame;
@@ -1060,104 +1202,86 @@ t4_eth_tx(void *arg, mblk_t *frame)
 
 doorbell:
 		/* Fewer and fewer doorbells as the queue fills up */
-		if (eq->pending >= (1 << (fls(eq->qsize - eq->avail) / 2))) {
-			txq->txbytes += txinfo.len;
-			txq->txpkts++;
+		if (eq->tse_pending >=
+		    (1 << (fls(eq->tse_qsize - eq->tse_avail) / 2))) {
+			txq->stats.txbytes += txinfo.len;
+			txq->stats.txpkts++;
 			t4_tx_ring_db(txq);
 		}
-		(void) t4_tx_reclaim_descs(txq, 32, NULL);
+		(void) t4_tx_reclaim_credits(txq, 32, NULL);
 	}
 
 	if (txpkts.npkt > 0) {
 		write_txpkts_wr(txq, &txpkts);
 	}
 
-	if (eq->pending != 0) {
+	if (eq->tse_pending != 0) {
 		t4_tx_ring_db(txq);
 	}
 
 	if (frame != NULL) {
-		eq->flags |= EQ_CORKED;
+		eq->tse_flags |= EQ_CORKED;
 	}
 
-	(void) t4_tx_reclaim_descs(txq, eq->qsize, NULL);
+	(void) t4_tx_reclaim_credits(txq, eq->tse_qsize, NULL);
 	TXQ_UNLOCK(txq);
 
 	return (frame);
 }
 
-static inline void
-init_iq(struct sge_iq *iq, struct adapter *sc, int tmr_idx, int8_t pktc_idx,
-    int qsize, uint8_t esize)
-{
-	ASSERT(tmr_idx >= 0 && tmr_idx < SGE_NTIMERS);
-	ASSERT(pktc_idx < SGE_NCOUNTERS);	/* -ve is ok, means don't use */
-
-	iq->flags = 0;
-	iq->adapter = sc;
-	iq->intr_params = V_QINTR_TIMER_IDX(tmr_idx);
-	iq->intr_pktc_idx = -1;
-	if (pktc_idx >= 0) {
-		iq->intr_params |= TIC_SE_INTR_ARM;
-		iq->intr_pktc_idx = pktc_idx;
-	}
-	iq->qsize = roundup(qsize, 16);		/* See FW_IQ_CMD/iqsize */
-	iq->esize = max(esize, 16);		/* See FW_IQ_CMD/iqesize */
-}
-
-static inline void
-init_fl(struct sge_fl *fl, uint16_t qsize)
+static int
+t4_alloc_iq(struct port_info *pi, const t4_iq_params_t *tip, t4_sge_iq_t *iq,
+    struct sge_fl *fl)
 {
+	struct adapter *sc = pi->adapter;
+	int rc;
 
-	fl->qsize = qsize;
-	fl->allocb_fail = 0;
-}
-
-/*
- * Allocates the ring for an ingress queue and an optional freelist.  If the
- * freelist is specified it will be allocated and then associated with the
- * ingress queue.
- *
- * Returns errno on failure.  Resources allocated up to that point may still be
- * allocated.  Caller is responsible for cleanup in case this function fails.
- *
- * If the ingress queue will take interrupts directly (iq->flags & IQ_INTR) then
- * the intr_idx specifies the vector, starting from 0.  Otherwise it specifies
- * the index of the queue to which its interrupts will be forwarded.
- */
-static int
-alloc_iq_fl(struct port_info *pi, struct sge_iq *iq, struct sge_fl *fl,
-    int intr_idx, int cong)
-{
-	int rc, i;
-	size_t len;
-	struct fw_iq_cmd c;
-	struct adapter *sc = iq->adapter;
-	uint32_t v = 0;
-
-	len = iq->qsize * iq->esize;
-	rc = alloc_desc_ring(sc, len, DDI_DMA_READ, &iq->dhdl, &iq->ahdl,
-	    &iq->ba, (caddr_t *)&iq->desc);
-	if (rc != 0)
-		return (rc);
+	ASSERT(tip->tip_tmr_idx >= 0 && tip->tip_tmr_idx < SGE_NTIMERS);
+	ASSERT(tip->tip_pktc_idx < SGE_NCOUNTERS);
+	ASSERT(tip->tip_cong_chan == -1 || tip->tip_cong_chan > 0);
 
-	bzero(&c, sizeof (c));
-	c.op_to_vfn = cpu_to_be32(V_FW_CMD_OP(FW_IQ_CMD) | F_FW_CMD_REQUEST |
-	    F_FW_CMD_WRITE | F_FW_CMD_EXEC | V_FW_IQ_CMD_PFN(sc->pf) |
-	    V_FW_IQ_CMD_VFN(0));
+	const bool intr_fwd = (tip->tip_intr_evtq != NULL);
+	const uint_t intr_idx =
+	    intr_fwd ? tip->tip_intr_evtq->tsi_cntxt_id : tip->tip_intr_idx;
 
-	c.alloc_to_len16 = cpu_to_be32(F_FW_IQ_CMD_ALLOC | F_FW_IQ_CMD_IQSTART |
-	    FW_LEN16(c));
+	ASSERT(intr_fwd || intr_idx < sc->intr_queue_cfg.intr_count);
 
-	/* Special handling for firmware event queue */
-	if (iq == &sc->sge.fwq)
-		v |= F_FW_IQ_CMD_IQASYNCH;
+	mutex_init(&iq->tsi_lock, NULL, MUTEX_DRIVER,
+	    DDI_INTR_PRI(DDI_INTR_PRI(sc->intr_pri)));
+	iq->tsi_flags = 0;
+	iq->tsi_iqtype = tip->tip_iq_type;
+	iq->tsi_adapter = sc;
+	iq->tsi_gts_rearm = V_QINTR_TIMER_IDX(tip->tip_tmr_idx);
+	iq->tsi_intr_pktc_idx = -1;
+	if (tip->tip_pktc_idx >= 0) {
+		iq->tsi_gts_rearm |= TGC_SE_INTR_ARM;
+		iq->tsi_intr_pktc_idx = tip->tip_pktc_idx;
+	}
 
-	if (iq->flags & IQ_INTR)
-		ASSERT(intr_idx < sc->intr_count);
-	else
-		v |= F_FW_IQ_CMD_IQANDST;
-	v |= V_FW_IQ_CMD_IQANDSTINDEX(intr_idx);
+	/*
+	 * The tsi_qsize holds the number of total entries in the queue, but the
+	 * device requires that this number be a multiple of 16. See the
+	 * documentation for FW_IQ_CMD in the Firmware Interface Book.
+	 */
+	iq->tsi_qsize = P2ROUNDUP(tip->tip_qsize, 16);
+	/*
+	 * The last entry is always reserved for the status page, even if status
+	 * page updates are not being utilized.
+	 */
+	iq->tsi_cap = iq->tsi_qsize - 1;
+	iq->tsi_esize = tip->tip_esize;
+	iq->tsi_esize_bytes = t4_iq_esize_bytes[iq->tsi_esize];
+	iq->tsi_intr_evtq = intr_fwd ? tip->tip_intr_evtq : NULL;
+	iq->tsi_intr_idx = intr_fwd ? INTR_FORWARDED : intr_idx;
+
+	const size_t len = iq->tsi_qsize * iq->tsi_esize_bytes;
+	rc = alloc_desc_ring(sc, len, DDI_DMA_READ, &iq->tsi_desc_dhdl,
+	    &iq->tsi_desc_ahdl, &iq->tsi_desc_ba, (caddr_t *)&iq->tsi_desc);
+	if (rc != 0) {
+		mutex_destroy(&iq->tsi_lock);
+		return (rc);
+	}
+	iq->tsi_flags |= IQ_ALLOC_HOST;
 
 	/*
 	 * If the coalescing counter is not enabled for this IQ, use the 0
@@ -1166,53 +1290,65 @@ alloc_iq_fl(struct port_info *pi, struct sge_iq *iq, struct sge_fl *fl,
 	 * The selected index does not matter when the counter is not enabled
 	 * through the GTS flags.
 	 */
-	const uint_t pktc_idx = (iq->intr_pktc_idx < 0) ? 0 : iq->intr_pktc_idx;
+	const uint_t pktc_idx = (iq->tsi_intr_pktc_idx < 0) ? 0 :
+	    iq->tsi_intr_pktc_idx;
+	const bool is_fwq = (iq == &sc->sge.fwq);
+
+	struct fw_iq_cmd iq_cmd;
+	bzero(&iq_cmd, sizeof (iq_cmd));
 
-	c.type_to_iqandstindex = cpu_to_be32(v |
+	iq_cmd.op_to_vfn = BE_32(V_FW_CMD_OP(FW_IQ_CMD) | F_FW_CMD_REQUEST |
+	    F_FW_CMD_WRITE | F_FW_CMD_EXEC | V_FW_IQ_CMD_PFN(sc->pf) |
+	    V_FW_IQ_CMD_VFN(0));
+
+	iq_cmd.alloc_to_len16 = BE_32(F_FW_IQ_CMD_ALLOC | F_FW_IQ_CMD_IQSTART |
+	    FW_LEN16(struct fw_iq_cmd));
+
+	iq_cmd.type_to_iqandstindex = BE_32(
+	    /* Special handling for firmware event queue */
+	    (is_fwq ? F_FW_IQ_CMD_IQASYNCH : 0) |
+	    (intr_fwd ? F_FW_IQ_CMD_IQANDST : 0) |
+	    V_FW_IQ_CMD_IQANDSTINDEX(intr_idx) |
 	    V_FW_IQ_CMD_TYPE(FW_IQ_TYPE_FL_INT_CAP) |
 	    V_FW_IQ_CMD_VIID(pi->viid) |
 	    V_FW_IQ_CMD_IQANUD(X_UPDATEDELIVERY_INTERRUPT));
-	c.iqdroprss_to_iqesize = cpu_to_be16(V_FW_IQ_CMD_IQPCIECH(pi->tx_chan) |
-	    F_FW_IQ_CMD_IQGTSMODE |
-	    V_FW_IQ_CMD_IQINTCNTTHRESH(pktc_idx) |
-	    V_FW_IQ_CMD_IQESIZE(ilog2(iq->esize) - 4));
-	c.iqsize = cpu_to_be16(iq->qsize);
-	c.iqaddr = cpu_to_be64(iq->ba);
-	if (cong >= 0) {
-		const uint32_t iq_type =
-		    cong ? FW_IQ_IQTYPE_NIC : FW_IQ_IQTYPE_OFLD;
-		c.iqns_to_fl0congen = BE_32(F_FW_IQ_CMD_IQFLINTCONGEN |
-		    V_FW_IQ_CMD_IQTYPE(iq_type));
-	}
+
+	iq_cmd.iqdroprss_to_iqesize = BE_16(V_FW_IQ_CMD_IQPCIECH(pi->tx_chan) |
+	    F_FW_IQ_CMD_IQGTSMODE | V_FW_IQ_CMD_IQINTCNTTHRESH(pktc_idx) |
+	    V_FW_IQ_CMD_IQESIZE(iq->tsi_esize));
+
+	iq_cmd.iqsize = BE_16(iq->tsi_qsize);
+	iq_cmd.iqaddr = BE_64(iq->tsi_desc_ba);
+	iq_cmd.iqns_to_fl0congen = tip->tip_cong_chan == -1 ? 0 :
+	    BE_32(F_FW_IQ_CMD_IQFLINTCONGEN);
+
+	/*
+	 * This setting currently only pertains to T4/T5 parts with 2 ports, and
+	 * its only effect is to correct a bug in setting the IQPCIECH related
+	 * to offload queues (Chelsio bug#34516). Therefore, setting it is
+	 * irrelevant for our driver. However, we set it anyways in case a
+	 * future part or fimrware revision decides to use this information for
+	 * other purposes relevant the behavior of our driver.
+	 */
+	iq_cmd.iqns_to_fl0congen |= BE_32(V_FW_IQ_CMD_IQTYPE(FW_IQ_IQTYPE_NIC));
 
 	if (fl != NULL) {
-		mutex_init(&fl->lock, NULL, MUTEX_DRIVER,
-		    DDI_INTR_PRI(sc->intr_pri));
-		fl->flags |= FL_MTX;
-
-		len = fl->qsize * RX_FL_ESIZE;
-		rc = alloc_desc_ring(sc, len, DDI_DMA_WRITE, &fl->dhdl,
-		    &fl->ahdl, &fl->ba, (caddr_t *)&fl->desc);
-		if (rc != 0)
-			return (rc);
+		t4_sge_eq_t *eq = &fl->eq;
 
-		/* Allocate space for one software descriptor per buffer. */
-		fl->cap = (fl->qsize - sc->sge.stat_len / RX_FL_ESIZE) * 8;
-		fl->sdesc = kmem_zalloc(sizeof (struct fl_sdesc) * fl->cap,
-		    KM_SLEEP);
-		fl->needed = fl->cap;
-		fl->lowat = roundup(sc->sge.fl_starve_threshold, 8);
-
-		c.iqns_to_fl0congen |=
-		    cpu_to_be32(V_FW_IQ_CMD_FL0HOSTFCMODE(X_HOSTFCMODE_NONE) |
-		    F_FW_IQ_CMD_FL0PACKEN | F_FW_IQ_CMD_FL0PADEN);
-		if (cong >= 0) {
-			c.iqns_to_fl0congen |=
-			    BE_32(V_FW_IQ_CMD_FL0CNGCHMAP(cong) |
-			    F_FW_IQ_CMD_FL0CONGCIF |
-			    F_FW_IQ_CMD_FL0CONGEN);
+		iq->tsi_fl = fl;
+		bzero(&fl->stats, sizeof (fl->stats));
+
+		fl->bufs_cap = tip->tip_fl_qsize;
+		eq->tse_flags = 0;
+		eq->tse_qsize = EQ_FLITS_TO_HC(fl->bufs_cap);
+
+		if ((rc = t4_alloc_eq_base(pi, eq)) != 0) {
+			t4_free_iq(pi, iq);
+			return (rc);
 		}
 
+		fl->bufs_lowat = P2ROUNDUP(sc->sge.fl_starve_threshold, 8);
+
 		/*
 		 * In T6, for egress queue type FL there is internal overhead
 		 * of 16B for header going into FLM module.  Hence the maximum
